// HKHSetting.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "HKHSetting.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>
#include <commdlg.h>

/* Defines */
#define	HOOKKEYHOOK_SETTING_REGKEY	_T("Software\\HookKeyHook")
#define	HOOKKEYHOOK_OFFHOOK_PATH	_T("OffHookKey_cmd")
#define	HOOKKEYHOOK_OFFHOOK_ARG		_T("OffHookKey_arg")
#define	HOOKKEYHOOK_ONHOOK_PATH		_T("OnHookKey_cmd")
#define	HOOKKEYHOOK_ONHOOK_ARG		_T("OnHookKey_arg")
#define	HOOKKEYHOOK_SLIDEOPEN_PATH	_T("SlideOpen_cmd")
#define	HOOKKEYHOOK_SLIDEOPEN_ARG	_T("SlideOpen_arg")
#define	HOOKKEYHOOK_SLIDECLOSE_PATH	_T("SlideClose_cmd")
#define	HOOKKEYHOOK_SLIDECLOSE_ARG	_T("SlideClose_arg")

#define GSGETFILE_DLLNAME	_T("gsgetfile.dll")
#define GSGETOPENFILENAME	_T("gsGetOpenFileName")

#define MAX_LOADSTRING 100

/* Typedefs */
typedef BOOL (* PFNGETOPENFILENAME) (OPENFILENAME*);
typedef BOOL (* PFNGETSAVEFILENAME) (OPENFILENAME*);

/* Global Variables */
HINSTANCE			g_hInst;				// The current instance
HWND				g_hwndCB;				// The command bar handle
static SHACTIVATEINFO s_sai;

// Forward declarations of functions included in this code module:
LRESULT CALLBACK	DialogProc (HWND, UINT, WPARAM, LPARAM);

static
BOOL
GetOpenFileNameEx(OPENFILENAME* pofn)
{
	BOOL				bRet = FALSE;
	HINSTANCE			hModule = NULL;
	PFNGETOPENFILENAME	pfnGetOpenFileName = NULL;

	bRet = FALSE;

	hModule =  LoadLibrary(GSGETFILE_DLLNAME);
	if (hModule != NULL) {
		pfnGetOpenFileName = (PFNGETOPENFILENAME)GetProcAddress(hModule, GSGETOPENFILENAME);
	}

	if (pfnGetOpenFileName != NULL) {
		bRet = (*pfnGetOpenFileName)(pofn);
	}
	else {
		bRet = GetOpenFileName(pofn);
	}

	if (hModule != NULL) {
		FreeLibrary(hModule);
		hModule = NULL;
		pfnGetOpenFileName = NULL;
	}

	return bRet;
}

static
BOOL
ReadSettingsString(
	LPTSTR	pValueName,
	LPTSTR	pStr,
	DWORD	dwStrSize
)
{
	BOOL	bRet;
	LONG	lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (pValueName == NULL || pStr == NULL) {
		return FALSE;
	}

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = 0;
		DWORD	dwSize = 0;

		dwSize = dwStrSize;
		lResult = RegQueryValueEx(hKey, pValueName, NULL, &dwType, (LPBYTE)pStr, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
BOOL
WriteSettingsString(
	LPTSTR	pValueName,
	LPTSTR	pStr
)
{
	BOOL	bRet;
	LONG	lResult;
	DWORD	dwDisposition;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (pValueName == NULL || pStr == NULL) {
		return FALSE;
	}

	lResult = RegCreateKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, _T(""), 0, 0, NULL, &hKey, &dwDisposition);

	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = REG_SZ;
		DWORD	dwSize = 0;

		dwSize = (_tcslen(pStr) + 1)*sizeof(TCHAR);
		lResult = RegSetValueEx(hKey, pValueName, 0, dwType, (LPBYTE)pStr, dwSize);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
BOOL
DeleteSettingsString(
	LPTSTR	pValueName
)
{
	BOOL	bRet;
	LONG	lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (pValueName == NULL) {
		return FALSE;
	}

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {

		lResult = RegDeleteValue(hKey, pValueName);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
BOOL
IsBlankString(
	LPTSTR	pStr
)
{
	BOOL	bRet;
	LPTSTR	p;

	bRet = TRUE;

	if (pStr == NULL) {
		return TRUE;
	}

	for (p = pStr; *p != TEXT('\0'); p++) {
		if (*p != TEXT(' ')) {
			bRet = FALSE;
			break;
		}
	}

	return bRet;
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	g_hInst = hInstance;
	DialogBox(hInstance, (LPCTSTR)IDD_HKHSETTING, NULL, (DLGPROC)DialogProc);
	return 0;
}

HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = g_hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}

BOOL
HKHGetFileName(
	HWND	hDlg,		// IN
	LPTSTR	pFileName,	// OUT
	DWORD	dwSize		// IN	pFileName̕(I[܂)
)
{
	BOOL	bRet;
	OPENFILENAME	ofn;

	bRet = FALSE;

	if (pFileName == NULL) {
		return FALSE;
	}

	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hDlg;
	ofn.lpstrFile = pFileName;
	ofn.nMaxFile = dwSize;
	ofn.lpstrTitle = L"̧قJ...";
	ofn.lpstrFilter = L"ş (*.exe)\0*.exe\0SĂ̧ (*.*)\0*.*\0\0";
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST |OFN_PATHMUSTEXIST;
	ofn.lpstrInitialDir = NULL;

	bRet = GetOpenFileNameEx(&ofn);

	return bRet;
}

// Mesage handler for the About box.
LRESULT CALLBACK DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			{
				TCHAR	szSetting[MAX_PATH + 1];

				// Create a Done button and size it.  
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);

				// 
				CreateRpCommandBar(hDlg);
				//

				// ݒ̓ǂݍ
				// OffHook cmd
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_OFFHOOK_PATH, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT, _T(""));
				}

				// OffHook arg
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_OFFHOOK_ARG, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT, _T(""));
				}

				// OnHook cmd
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_ONHOOK_PATH, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT, _T(""));
				}

				// OnHook arg
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_ONHOOK_ARG, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT, _T(""));
				}
				//

				// SlideOpen cmd
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_SLIDEOPEN_PATH, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_SLIDEOPEN_PATH_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_SLIDEOPEN_PATH_EDIT, _T(""));
				}

				// SlideOpen arg
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_SLIDEOPEN_ARG, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_SLIDEOPEN_OPTION_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_SLIDEOPEN_OPTION_EDIT, _T(""));
				}

				// SlideClose cmd
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_SLIDECLOSE_PATH, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_SLIDECLOSE_PATH_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_SLIDECLOSE_PATH_EDIT, _T(""));
				}

				// SlideClose arg
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_SLIDECLOSE_ARG, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_SLIDECLOSE_OPTION_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_SLIDECLOSE_OPTION_EDIT, _T(""));
				}
				//
			}
			return TRUE;
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDOK:
				{
					int		iRet;
					TCHAR	szSetting[MAX_PATH + 1];

					iRet = MessageBox(hDlg, _T("ݒ𔽉f܂H"), _T("HKHSetting"), MB_OK|MB_YESNO|MB_ICONQUESTION);
					if (iRet == IDYES) {

						// ݒ̏
						// OffHook cmd
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_OFFHOOK_PATH, szSetting);
						}
						else {
							DeleteSettingsString(HOOKKEYHOOK_OFFHOOK_PATH);
						}

						// OffHook arg
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_OFFHOOK_ARG, szSetting);
						}
						else {
							DeleteSettingsString(HOOKKEYHOOK_OFFHOOK_ARG);
						}

						// OnHook cmd
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_ONHOOK_PATH, szSetting);
						}
						else {
							DeleteSettingsString(HOOKKEYHOOK_ONHOOK_PATH);
						}

						// OnHook arg
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_ONHOOK_ARG, szSetting);
						}
						else {
							DeleteSettingsString(HOOKKEYHOOK_ONHOOK_ARG);
						}
						//

						// SlideOpen cmd
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_SLIDEOPEN_PATH_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_SLIDEOPEN_PATH, szSetting);
						}
						else {
							DeleteSettingsString(HOOKKEYHOOK_SLIDEOPEN_PATH);
						}

						// SlideClose arg
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_SLIDEOPEN_OPTION_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_SLIDEOPEN_ARG, szSetting);
						}
						else {
							DeleteSettingsString(HOOKKEYHOOK_SLIDEOPEN_ARG);
						}

						// SlideClose cmd
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_SLIDECLOSE_PATH_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_SLIDECLOSE_PATH, szSetting);
						}
						else {
							DeleteSettingsString(HOOKKEYHOOK_SLIDECLOSE_PATH);
						}

						// SlideClose arg
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_SLIDECLOSE_OPTION_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_SLIDECLOSE_ARG, szSetting);
						}
						else {
							DeleteSettingsString(HOOKKEYHOOK_SLIDECLOSE_ARG);
						}
						//

						EndDialog(hDlg, LOWORD(wParam));
						CommandBar_Destroy(g_hwndCB);
					}

				}
				return TRUE;
				break;

			case IDCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				CommandBar_Destroy(g_hwndCB);
				return TRUE;
				break;

			case IDC_OFFHOOK_REF:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_OFFHOOK_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;
			case IDC_ONHOOK_REF:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_ONHOOK_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			case IDC_SLIDEOPEN_REF:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_SLIDEOPEN_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			case IDC_SLIDECLOSE_REF:
				{
					TCHAR			szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_SLIDECLOSE_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;
			}
			break;
	}
    return FALSE;
}
